# Eiffel API client for swagger

This is a sample server Petstore server.  You can find out more about Swagger at [http://swagger.io](http://swagger.io) or on [irc.freenode.net, #swagger](http://swagger.io/irc/).  For this sample, you can use the api key `special-key` to test the authorization filters.

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.EiffelClientCodegen

## Installation
Add the library into your Eiffel configuration file.
```
    "<library name="api_client" location="%PATH_TO_EIFFEL_SWAGGER_CLIENT%\api_client.ecf"/>"
```

## Documentation for API Endpoints

All URIs are relative to *http://petstore.swagger.io/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*PET_API* | [**add_pet**](docs/PET_API.md#add_pet) | **Post** /pet | Add a new pet to the store
*PET_API* | [**delete_pet**](docs/PET_API.md#delete_pet) | **Delete** /pet/{petId} | Deletes a pet
*PET_API* | [**find_pets_by_status**](docs/PET_API.md#find_pets_by_status) | **Get** /pet/findByStatus | Finds Pets by status
*PET_API* | [**find_pets_by_tags**](docs/PET_API.md#find_pets_by_tags) | **Get** /pet/findByTags | Finds Pets by tags
*PET_API* | [**pet_by_id**](docs/PET_API.md#pet_by_id) | **Get** /pet/{petId} | Find pet by ID
*PET_API* | [**update_pet**](docs/PET_API.md#update_pet) | **Put** /pet | Update an existing pet
*PET_API* | [**update_pet_with_form**](docs/PET_API.md#update_pet_with_form) | **Post** /pet/{petId} | Updates a pet in the store with form data
*PET_API* | [**upload_file**](docs/PET_API.md#upload_file) | **Post** /pet/{petId}/uploadImage | uploads an image
*STORE_API* | [**delete_order**](docs/STORE_API.md#delete_order) | **Delete** /store/order/{orderId} | Delete purchase order by ID
*STORE_API* | [**inventory**](docs/STORE_API.md#inventory) | **Get** /store/inventory | Returns pet inventories by status
*STORE_API* | [**order_by_id**](docs/STORE_API.md#order_by_id) | **Get** /store/order/{orderId} | Find purchase order by ID
*STORE_API* | [**place_order**](docs/STORE_API.md#place_order) | **Post** /store/order | Place an order for a pet
*USER_API* | [**create_user**](docs/USER_API.md#create_user) | **Post** /user | Create user
*USER_API* | [**create_users_with_array_input**](docs/USER_API.md#create_users_with_array_input) | **Post** /user/createWithArray | Creates list of users with given input array
*USER_API* | [**create_users_with_list_input**](docs/USER_API.md#create_users_with_list_input) | **Post** /user/createWithList | Creates list of users with given input array
*USER_API* | [**delete_user**](docs/USER_API.md#delete_user) | **Delete** /user/{username} | Delete user
*USER_API* | [**login_user**](docs/USER_API.md#login_user) | **Get** /user/login | Logs user into the system
*USER_API* | [**logout_user**](docs/USER_API.md#logout_user) | **Get** /user/logout | Logs out current logged in user session
*USER_API* | [**update_user**](docs/USER_API.md#update_user) | **Put** /user/{username} | Updated user
*USER_API* | [**user_by_name**](docs/USER_API.md#user_by_name) | **Get** /user/{username} | Get user by user name


## Documentation For Models

 - [API_RESPONSE](docs/API_RESPONSE.md)
 - [CATEGORY](docs/CATEGORY.md)
 - [ORDER](docs/ORDER.md)
 - [PET](docs/PET.md)
 - [TAG](docs/TAG.md)
 - [USER](docs/USER.md)


## Documentation For Authorization


## api_key

- **Type**: API key 
- **API key parameter name**: api_key
- **Location**: HTTP header

## petstore_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: http://petstore.swagger.io/api/oauth/dialog
- **Scopes**: 
 - **write:pets**: modify pets in your account
 - **read:pets**: read your pets


## Author

apiteam@swagger.io

